//+------------------------------------------------------------------+
//|                                  TA_TMA+KIJUN_MID.mq4            !
//|    Kijun.Per, KJ.TMA.Per, MA.TMA.Per,  MA.Price, MA.Mode         ! 
//+------------------------------------------------------------------+
#property copyright "AHGDP"
#property link      "TA_TMA+KIJUN_MID"

#property indicator_chart_window
#property indicator_buffers    6
#property indicator_color1     clrAqua
#property indicator_color2     clrRed // Yellow ? of dalk Orange?
#property indicator_color3     clrNONE //Yellow
#property indicator_color4     clrNONE//Magenta
#property indicator_color5     clrNONE//Aqua
#property indicator_color6     clrNONE//Gold

extern int    Kijun_Per        = 3;
extern int    KJ_TMA_Per       = 3;
extern int    MA_TMA_Per       = 3;
extern int    MA_Price         = PRICE_CLOSE;// _MEDIAN
extern int    MA_Mode          = 0;

extern int    LineSize1       = 3 ;
extern int    LineStyle1      = 0 ;

extern bool   ShowDOT         = true;//************
extern int    HMA_WINK1       = 0;
extern int    Adj_UpDn        = 150;
extern int    Adj_LtRt        = 125;

extern int    DotSize         = 100 ;

extern int    CountBars      = 500 ;
extern int Precision = 6;

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(6);
   IndicatorDigits(Precision);
   
   MA_TMA_Per = MathMax(MA_TMA_Per,1);
   KJ_TMA_Per = MathMax(KJ_TMA_Per,1);
    
   SetIndexStyle (0, DRAW_LINE, LineStyle1, LineSize1 );
   SetIndexBuffer(0, buffer1);
   SetIndexStyle (1, DRAW_LINE, LineStyle1, LineSize1 );
   SetIndexBuffer(1, buffer2);
   
   SetIndexStyle (2, DRAW_LINE, LineStyle1, 1 );
   SetIndexBuffer(2, buffer3);
   SetIndexStyle (3, DRAW_LINE, LineStyle1, 1 );
   SetIndexBuffer(3, buffer4);
   
   SetIndexStyle (4, DRAW_LINE, LineStyle1, 1 );
   SetIndexBuffer(4, buffer5);
   SetIndexStyle (5, DRAW_LINE, LineStyle1, 1 );
   SetIndexBuffer(5, buffer6);
  
      
     IndicatorShortName(""); 
  
//=================================================      
   
   return(0);
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int deinit() 
    {  Refresh() ;
       return(0);
    }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int start()
{   Refresh(); 
   int counted_bars=IndicatorCounted();
   int i,j,k,limit;
   
     SetIndexDrawBegin(0,Bars-CountBars);
     SetIndexDrawBegin(1,Bars-CountBars);
     SetIndexDrawBegin(2,Bars-CountBars);
     SetIndexDrawBegin(3,Bars-CountBars);
     SetIndexDrawBegin(4,Bars-CountBars);
     SetIndexDrawBegin(5,Bars-CountBars);
   int S1H,S1V;
  
     if  (HMA_WINK1 == 0||1||2||3 )
  {   
     S1H    = 1 +Adj_LtRt  ;  S1V    = 30 +Adj_UpDn ; 
                  
  }      
     
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars+MA_TMA_Per);
       //     if (returnBars)  { buffer1[0] = limit+1; return(0); }
       
//============================================================================================
 
   
     { for (i=limit; i>=0; i--)
      {
         double sum  = (KJ_TMA_Per+1)*iIchimoku(NULL, 0, 1, Kijun_Per , 1, MODE_KIJUNSEN, i);
         double sumw = (KJ_TMA_Per+1);
                
         for(j=1, k=KJ_TMA_Per; j<=KJ_TMA_Per; j++, k--)
         {
            sum  += k* iIchimoku(NULL, 0, 1, Kijun_Per , 1, MODE_KIJUNSEN, i+j);
            sumw += k;

            if (j<=i)
            {
               sum  += k*iIchimoku(NULL, 0, 1, Kijun_Per , 1, MODE_KIJUNSEN, i-j);
               sumw += k;
            }          
        } 
              buffer3[i] = sum/sumw;
              
  }   

//==================================================================================================================       
  for (i=limit; i>=0; i--)
   {   buffer4[i] = EMPTY_VALUE;
      
      if   ( buffer3[i + 1] < buffer3[i] )  {buffer4[i + 1] = buffer4[i + 1];
                                                 buffer4[i] = buffer4[i];
                                            }
     else 
          {  if  (buffer3[i + 1] > buffer3[i])
                 {   if (buffer4[i + 1] == EMPTY_VALUE) buffer4[i + 1] = buffer3[i + 1];
                                                         buffer4[i] = buffer3[i];
   }      }      }   
  
  }
  
//===========================================================================================        
//============================================================================================
 
   
     { for (i=limit; i>=0; i--)
      {
         double Asum  = (MA_TMA_Per+1)*iMA(NULL,0,1,0,MA_Mode,MA_Price,i);
         double Asumw = (MA_TMA_Per+1);
                
         for(j=1, k=MA_TMA_Per; j<=MA_TMA_Per; j++, k--)
         {
            Asum  += k*iMA(NULL,0,1,0,MA_Mode,MA_Price,i+j);
            Asumw += k;

            if (j<=i)
            {
               Asum  += k*iMA(NULL,0,1,0,MA_Mode,MA_Price,i-j);
               Asumw += k;
            }          
        } 
              buffer5[i] = Asum/Asumw;
              
  }   

//==================================================================================================================       
  for (i=limit; i>=0; i--)
   {   buffer6[i] = EMPTY_VALUE;
      
      if   ( buffer5[i + 1] < buffer5[i] )  {buffer6[i + 1] = buffer6[i + 1];
                                                 buffer6[i] = buffer6[i];
                                            }
     else 
          {  if  (buffer5[i + 1] > buffer5[i])
                 {   if (buffer6[i + 1] == EMPTY_VALUE) buffer6[i + 1] = buffer5[i + 1];
                                                         buffer6[i] = buffer5[i];
   }      }      }   
  
  }
  
//=========================================================================================== 
   
     for (i=limit; i>=0; i--)
     {
        buffer1[i] = (buffer3[i] + buffer5[i])/2;
     }
//==================================================================================================================       
  for (i=limit; i>=0; i--)
   {   buffer2[i] = EMPTY_VALUE;
      
      if   ( buffer1[i + 1] < buffer1[i] )  {buffer2[i + 1] = buffer2[i + 1];
                                                 buffer2[i] = buffer2[i];
                                            }
     else 
          {  if  (buffer1[i + 1] > buffer1[i])
                 {   if (buffer2[i + 1] == EMPTY_VALUE) buffer2[i + 1] = buffer1[i + 1];
                                                         buffer2[i] = buffer1[i];
   }      }      }   
  
      
//======================================================================================================
 if (ShowDOT)
 {for (i=limit; i>=0; i--)
{                                  ObjectCreate ("HM1_labK1", OBJ_LABEL,HMA_WINK1, 0, 0);
                                   ObjectSet    ("HM1_labK1", OBJPROP_CORNER, 3);
   if  (buffer2[i]== EMPTY_VALUE ){ObjectSetText("HM1_labK1", "l",DotSize, "Wingdings", clrLime);}
   if  (buffer2[i]!= EMPTY_VALUE ){ObjectSetText("HM1_labK1", "l",DotSize, "Wingdings", clrRed);}
  // if  ( (K[i] == D[i]) &&  (K[i] > 90) ) {ObjectSetText("HM1_labK1","l",DotSize, "Wingdings", Maroon);}
  // if  ( (K[i] == D[i]) &&  (K[i] < 10) ) {ObjectSetText("HM1_labK1","l",DotSize, "Wingdings", Green);}
                                   ObjectSet    ("HM1_labK1", OBJPROP_XDISTANCE, S1H);
                                   ObjectSet    ("HM1_labK1", OBJPROP_YDISTANCE, S1V ); 
   } }
//======================================================================================================  
   return(0);
}
//=====================================================================================================
void Refresh() 
   {            ObjectDelete("HM1_labK1"); 
                             
   }
//=====================================================================================================   

